﻿// Keep these lines for a best effort IntelliSense of Visual Studio 2017.
/// <reference path="../../Packages/Beckhoff.TwinCAT.HMI.Framework.12.742.5/runtimes/native1.12-tchmi/TcHmi.d.ts" />

(function (/** @type {globalThis.TcHmi} */ TcHmi) {
    // If you want to unregister an event outside the event code you need to use the return value of the method register()
    var destroyOnInitialized = TcHmi.EventProvider.register('onInitialized', function (e, data) {
        // This event will be raised only once, so we can free resources. 
        // It's best practice to use destroy function of the event object within the callback function to avoid conflicts.
        e.destroy();


        //1 Manage LockStatus view  to Desktop view
        // put this function block before the previous one otherwise it not work.
        var destroyEvent = TcHmi.EventProvider.register(
            'TcHmi_Controls_Beckhoff_TcHmiImage_LockToDesktop.onPressed',
            function (evt, data) {
                var v1 = TcHmi.View.get();
                console.log(v1.getId());
                TcHmi.View.load('Desktop.view', function (data) {
                    var v2 = TcHmi.View.get();
                    console.log(v2.getId());
                });
                // Destroy to free event resources if event is no longer needed.
                //But comment out if you need it
                //destroyEvent();
            }
        );


        var destroyEvent = TcHmi.EventProvider.register(
            'TcHmi_Controls_Beckhoff_TcHmiImage_DesktopLock.onPressed',
            function (evt, data) {

                var v1 = TcHmi.View.get();
                console.log(v1.getId());
                TcHmi.View.load('LockStatus.view', function (data) {
                    var v2 = TcHmi.View.get();
                    console.log(v2.getId());
                });

                // Destroy to free event resources if event is no longer needed.
                //But comment out if you need it
                //destroyEvent();
            }
        );


        //2 Manage Thermometer view  to Desktop view
        // put this function block before the previous one otherwise it not work.
        var destroyEvent = TcHmi.EventProvider.register(
            'TcHmi_Controls_Beckhoff_TcHmiImage_ThermoToDesktop.onPressed',
            function (evt, data) {
                var v1 = TcHmi.View.get();
                console.log(v1.getId());
                TcHmi.View.load('Desktop.view', function (data) {
                    var v2 = TcHmi.View.get();
                    console.log(v2.getId());
                });
                // Destroy to free event resources if event is no longer needed.
                //But comment out if you need it
                //destroyEvent();
            }
        );


        var destroyEvent = TcHmi.EventProvider.register(
            'TcHmi_Controls_Beckhoff_TcHmiImage_DesktopThermometer.onPressed',
            function (evt, data) {

                var v1 = TcHmi.View.get();
                console.log(v1.getId());
                TcHmi.View.load('ThermometerStatus.view', function (data) {
                    var v2 = TcHmi.View.get();
                    console.log(v2.getId());
                });

                // Destroy to free event resources if event is no longer needed.
                //But comment out if you need it
                //destroyEvent();
            }
        );

        //3 Manage Water Valve view  to Desktop view
        // put this function block before the previous one otherwise it not work.
        var destroyEvent = TcHmi.EventProvider.register(
            'TcHmi_Controls_Beckhoff_TcHmiImage_WaterValveToDesktop.onPressed',
            function (evt, data) {
                var v1 = TcHmi.View.get();
                console.log(v1.getId());
                TcHmi.View.load('Desktop.view', function (data) {
                    var v2 = TcHmi.View.get();
                    console.log(v2.getId());
                });
                // Destroy to free event resources if event is no longer needed.
                //But comment out if you need it
                //destroyEvent();
            }
        );


        var destroyEvent = TcHmi.EventProvider.register(
            'TcHmi_Controls_Beckhoff_TcHmiImage_DesktopValve.onPressed',
            function (evt, data) {

                var v1 = TcHmi.View.get();
                console.log(v1.getId());
                TcHmi.View.load('WaterValve.view', function (data) {
                    var v2 = TcHmi.View.get();
                    console.log(v2.getId());
                });

                // Destroy to free event resources if event is no longer needed.
                //But comment out if you need it
                //destroyEvent();
            }
        );

        //4 Manage Yard Door view  to Desktop view
        // put this function block before the previous one otherwise it not work.
        var destroyEvent = TcHmi.EventProvider.register(
            'TcHmi_Controls_Beckhoff_TcHmiImage_YardDoorToDesktop.onPressed',
            function (evt, data) {
                var v1 = TcHmi.View.get();
                console.log(v1.getId());
                TcHmi.View.load('Desktop.view', function (data) {
                    var v2 = TcHmi.View.get();
                    console.log(v2.getId());
                });
                // Destroy to free event resources if event is no longer needed.
                //But comment out if you need it
                //destroyEvent();
            }
        );


        var destroyEvent = TcHmi.EventProvider.register(
            'TcHmi_Controls_Beckhoff_TcHmiImage_DesktopYardDoor.onPressed',
            function (evt, data) {

                var v1 = TcHmi.View.get();
                console.log(v1.getId());
                TcHmi.View.load('YardDoor.view', function (data) {
                    var v2 = TcHmi.View.get();
                    console.log(v2.getId());
                });

                // Destroy to free event resources if event is no longer needed.
                //But comment out if you need it
                //destroyEvent();
            }
        );




    });
})(TcHmi);
